; following steps in Green Apple tutorial by conbagui
; found at link: http://gimpchat.com/viewtopic.php?f=23&t=9976
; author: Tin Tran
; date: 2014

(define (script-fu-green-apple 
                         light-green-color
						 dark-green-color
						 dots-color
						 yellow1-color
						 yellow2-color
						 stem-color
						 stem-highlight-color
						 stem-shadow-color
						 background-dark-color
						 background-light-color
						 new-image-width
         )
	(let* 
	  (
	  (dummy-variable-to-make-let-happy 0)
	  (width 1600)
	  (height 1200)
	  (image)
	  (background-layer)
	  (green-apple-layer)
	  (inner-shadow-layer)
	  (texture-layer)
	  (dots-layer)
	  (brush-name)
	  (i 0)           ;counter
	  (x) (y)         ;dots coordinates
	  (point (cons-array 2 'double)) ;point array to use for creating random dots
	  (array256 (cons-array 256 'double)) ;not used, to be passed in as freehand coords for curve bend, it expects it
	  (dent-layer)
	  (dent-shadow-layer)
	  (dent-shadow-mask)
	  (highlight1-layer)
	  (highlight2-layer)
	  (yellow1-layer)
	  (yellow2-layer)
	  (reflection-layer)
	  (backlight-layer)
	  
	  (stalk-layer)
	  (stalk-highlight-layer)
	  (stalk-innershadow-layer)
	  (perspective-shadow-layer)
	  (stem-hide-layer)
	  
	  (stem-mask)
	  (path-vector)
	  (strokeid)
	  
	  (merged-layer)
	  (background-light-layer)
	  (shadow-layer)
	  (new-display)
	  
	  )
	;(gimp-image-undo-group-start image)                   ;undo-group in one step
	;STEP 1
	(set! image (car (gimp-image-new width height RGB)))      ;creates new image
	(set! background-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "background" 100 LAYER-MODE-NORMAL-LEGACY)))
	(gimp-drawable-fill background-layer FILL-WHITE)         ;fills background with white
	(gimp-image-insert-layer image background-layer 0 0) ;parent 0, insert layer on top position(0)
	;green-apple layer
	(set! green-apple-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Green Apple" 100 LAYER-MODE-NORMAL-LEGACY)))
	(gimp-image-insert-layer image green-apple-layer 0 0) ;parent 0, insert layer on top position(0)						   
	(gimp-image-set-active-layer image green-apple-layer)
	(gimp-ellipse-select image 400 200 800 800 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)

	;STEP 2
	(gimp-context-set-foreground light-green-color)
	(gimp-context-set-background dark-green-color)
	(gimp-context-set-gradient "FG to BG (RGB)")
	(gimp-edit-blend green-apple-layer
								  BLEND-CUSTOM
								  LAYER-MODE-NORMAL-LEGACY
								  GRADIENT-RADIAL ;gradient type
								  100 ;opacity
	                              0   ;offset
								  REPEAT-NONE
								  FALSE ;reverse
								  FALSE ;supersample
								  3     ;max-depth used if supersample
								  0.20  ;threshold used if supersample
								  TRUE  ; dithering
								  800   ; x start point
								  490   ; y start point
	                              1460   ; x end point
								  490    ; y end point
								  )
	
	;STEP 3
	(python-layer-fx-inner-shadow 1 image green-apple-layer '(0 0 0)
                                  75  ;opacity
                                  0   ;0 for Linear contour
                                  0   ;noise
								  LAYER-MODE-MULTIPLY-LEGACY   ;mode 19 for softlight  3 for multiply
								  1   ;source 0 for center 1 for edge check this one
								  0.0 ;choke
								  85  ;size
								  -90    ;offset-angle
								  50   ;offset-distance
								  FALSE ; merge with layer
	)
	(set! inner-shadow-layer (car (gimp-image-get-layer-by-name image "Green Apple-innershadow")))
	(gimp-image-set-active-layer image inner-shadow-layer)
	(plug-in-gauss RUN-NONINTERACTIVE image inner-shadow-layer
	                                        100 100
											1 ;1 RLE or 0 IIR
	                                        )
	
	;STEP 4
	(set! texture-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Texture" 40 LAYER-MODE-SOFTLIGHT-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image texture-layer 0 0)                     ;inserts layer into image before usable
	(plug-in-solid-noise RUN-NONINTERACTIVE image texture-layer
	                                               FALSE    ;Create a tilable output { TRUE, FALSE }
													FALSE   ;Make a turbulent noise { TRUE, FALSE }
	                                                0   ;Random seed
													2   ;Detail level (0 - 15)
	                                                2.8    ;Horizontal texture size(float)
													2.8	;Vertical texture size (float)
													)
    
	;STEP 5
	(set! dots-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Dots" 100 LAYER-MODE-OVERLAY-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image dots-layer 0 0)     
	(gimp-image-set-active-layer image dots-layer)
	(gimp-context-set-foreground dots-color)
	
	;sets brush to use with pencil tool later
	;(gimp-context-set-brush "2. Hardness 100")
	
	(set! brush-name (car(gimp-brush-new "apple dots")))
	(gimp-brush-set-hardness brush-name 100)
	(gimp-brush-set-radius brush-name 3.5)
	(gimp-brush-set-shape brush-name BRUSH-GENERATED-CIRCLE)
	(gimp-context-set-brush brush-name)         ;use created brush
	(gimp-context-set-brush-size 7)             ; this sets the brush size in context but doesn't seem to affect script's brush size
	
	(set! i 0)
	(while (< i 60)            ;creates some large dots
      (set! i (+ i 1))
	  (set! x (+ 400 (random 800)))            ;x to be random
	  (set! y (+ 200 (random 800)))            ;y to be random
	  (aset point 0 x)
	  (aset point 1 y)
	  (gimp-pencil dots-layer 2 point)       ;draw dots passing in the point array that holds (x,y)
    )
	
	(gimp-brush-set-radius brush-name 2) ;SOME SMALLER DOTS
	(set! i 0)
	(while (< i 60)            ;creates some large dots
      (set! i (+ i 1))
	  (set! x (+ 400 (random 800)))            ;x to be random
	  (set! y (+ 200 (random 800)))            ;y to be random
	  (aset point 0 x)
	  (aset point 1 y)
	  (gimp-pencil dots-layer 2 point)       ;draw dots passing in the point array that holds (x,y)
    )
	
	(plug-in-gauss RUN-NONINTERACTIVE image dots-layer
	                                        14 14
											1 ;1 RLE or 0 IIR
	                                        )
	
	;STEP 6
	(set! dent-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Dent" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image dent-layer 0 0)     
	(gimp-image-set-active-layer image dent-layer)
	(gimp-ellipse-select image 674 279 223 105 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	) ;selects white ellipse
	(gimp-edit-fill dent-layer FILL-WHITE)
	(set! dent-shadow-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Dent Shadow" 60 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image dent-shadow-layer 0 0)
	(gimp-image-set-active-layer image dent-shadow-layer)						   
	(gimp-ellipse-select image 731 338 114 150 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	) ;selects black ellipse
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill dent-shadow-layer FILL-FOREGROUND)
	
	(gimp-image-set-active-layer image dent-layer)
	(gimp-image-select-item image CHANNEL-OP-REPLACE dent-layer)  ;same as alpha to selection
	(gimp-image-set-active-layer image dent-shadow-layer)
	;MASK
	(set! dent-shadow-mask (car (gimp-layer-create-mask dent-shadow-layer ADD-MASK-SELECTION))) ;creates the mask before adding it
	(gimp-layer-add-mask dent-shadow-layer dent-shadow-mask)        ;adds mask to dent-shadow channel
	(gimp-layer-set-mode dent-layer LAYER-MODE-MULTIPLY-LEGACY)
	(plug-in-gauss RUN-NONINTERACTIVE image dent-shadow-layer
	                                        114 114
											1 ;1 RLE or 0 IIR
	                                        )
	;STEP 8
	(set! highlight1-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Highlight1" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image highlight1-layer 0 0)
	(gimp-image-set-active-layer image highlight1-layer)
	;oval of white
	(gimp-ellipse-select image 636 182 300 262 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-edit-fill highlight1-layer FILL-WHITE)
	(gimp-ellipse-select image 568 128 446 294 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-edit-cut highlight1-layer)   ;cut to finish layer
	
	
	;perform highlight2
	(set! highlight2-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Highlight2" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image highlight2-layer 0 0)
	(gimp-image-set-active-layer image highlight2-layer)
	;oval of white
	(gimp-ellipse-select image 609 240 360 339 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-edit-fill highlight2-layer FILL-WHITE)
	(gimp-ellipse-select image 525 265 533 356 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-edit-cut highlight2-layer)   ;cut to finish layer
	(gimp-selection-none image)
	;blur highlight1 and highlight2
	(plug-in-gauss RUN-NONINTERACTIVE image highlight1-layer
	                                        50 50
											1 ;1 RLE or 0 IIR
	                                        )
	(plug-in-gauss RUN-NONINTERACTIVE image highlight2-layer
	                                        50 50
											1 ;1 RLE or 0 IIR
	                                        )
	;STEP 9
	;yellow1 layer
	(set! yellow1-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Yellow1" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image yellow1-layer 0 0)
	(gimp-image-set-active-layer image yellow1-layer)
	;oval of white
	(gimp-ellipse-select image 492 544 250 250 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-context-set-foreground yellow1-color)
	(gimp-edit-fill yellow1-layer FILL-FOREGROUND)
	(gimp-image-select-item image CHANNEL-OP-REPLACE green-apple-layer)
	(plug-in-gauss RUN-NONINTERACTIVE image yellow1-layer
	                                        300 300
											1 ;1 RLE or 0 IIR
	                                        )
	(gimp-layer-set-mode yellow1-layer HUE-MODE)
	
	
	;yellow2 layer
	(set! yellow2-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Yellow2" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image yellow2-layer 0 0)
	(gimp-image-set-active-layer image yellow2-layer)
	;oval of white
	(gimp-ellipse-select image 422 454 450 450 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-context-set-foreground yellow2-color)
	(gimp-edit-fill yellow2-layer FILL-FOREGROUND)
	(gimp-image-select-item image CHANNEL-OP-REPLACE green-apple-layer)
	(plug-in-gauss RUN-NONINTERACTIVE image yellow2-layer
	                                        400 400
											1 ;1 RLE or 0 IIR
	                                        )
	(gimp-layer-set-mode yellow2-layer LAYER-MODE-OVERLAY-LEGACY)
	
	;STEP 10
	(set! reflection-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Reflection" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
    (gimp-image-insert-layer image reflection-layer 0 0)
	(gimp-image-set-active-layer image reflection-layer)
	(gimp-image-select-rectangle image CHANNEL-OP-REPLACE
	                                    (+ 30 707) (- 527 170)
	                                    238 131)
	(gimp-edit-fill reflection-layer FILL-WHITE)
	
	(gimp-image-select-rectangle image CHANNEL-OP-REPLACE
	                                    (+ 30 808) (- 514 170)
	                                    24 154)
	(gimp-edit-cut reflection-layer)	
	
	(gimp-image-select-rectangle image CHANNEL-OP-REPLACE
	                                    (+ 30 693) (- 578 170)
	                                    276 29)
	(gimp-edit-cut reflection-layer)	
	(gimp-selection-none image)
	(plug-in-curve-bend RUN-NONINTERACTIVE image reflection-layer 
	                                       0.0 ;rotation
										   TRUE    ;Smoothing {TRUE,FALSE}
											TRUE   ;antialias{TRUE,FALSE}
											FALSE   ;work on copy {TRUE,FALSE}
	                                        0   ;curve-type 0 smooth 1 freehand
											5   ;{2 <= argc <= 17} upper
	                                        #(0 0.14 0.5 0.84 1)   ; array of 17 x point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
											5   ; upper argc
											#(0.5 0.38 0.31 0.38 0.5)    ; array of 17 y point_koords { 0.0 <= y <= 1.0 or -1 for unused point }
											   
											5   ; lower argc
											#(0 0.14 0.5 0.84 1)   ; array of 17 x point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
	                                        5   ; lower argc for y
											#(0.5 0.38 0.31 0.38 0.5)   ; array of 17 y point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
	                                           
	                                        256   ;256 upper for free hand
											array256   ;array of 256 freehandkoord
											256   ;256 lower
											array256   ;array of 256 
	)
	(plug-in-gauss RUN-NONINTERACTIVE image reflection-layer
	                                        70 70
											1 ;1 RLE or 0 IIR
	                                        )
	;STEP 11
	(gimp-image-select-item image CHANNEL-OP-REPLACE green-apple-layer)
	(set! backlight-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Backlight" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image backlight-layer 0 0)     
	(gimp-image-set-active-layer image backlight-layer)
	;selection subtract smaller circle
	(gimp-ellipse-select image 430 230 740 740 CHANNEL-OP-SUBTRACT
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	;(gimp-selection-shrink image 15)
	;(gimp-selection-border image 30)
	(gimp-context-set-foreground '(255 255 255))
	(gimp-context-set-brush "2. Hardness 025")
	(gimp-context-set-brush-size 350)           ;context doesn't seem to change our brush effects 
	;so we'll set our own brush
	(gimp-brush-set-hardness brush-name .25)
	(gimp-brush-set-radius brush-name 100)
	(gimp-brush-set-spacing brush-name 20)
	(gimp-context-set-brush brush-name)      ;set it to our own created brush to use
	;paint over it a 3 times
	(gimp-paintbrush backlight-layer 
	                  0 ;fade out
					  6  ;num-strokes 4 since we're doing 2 points
	                  #(1140 432 1185 609 1137 783)   ;array
					  PAINT-CONSTANT ;PAINT-CONSTANT or PAINT-INCREMENTAL	 
					  0 ;length of gradient to draw
	)
	(gimp-paintbrush backlight-layer 
	                  0 ;fade out
					  6  ;num-strokes 4 since we're doing 2 points
	                  #(1140 432 1185 609 1137 783)   ;array
					  PAINT-CONSTANT ;PAINT-CONSTANT or PAINT-INCREMENTAL	 
					  0 ;length of gradient to draw
	)
	(gimp-paintbrush backlight-layer 
	                  0 ;fade out
					  6  ;num-strokes 4 since we're doing 2 points
	                  #(1140 432 1185 609 1137 783)   ;array
					  PAINT-CONSTANT ;PAINT-CONSTANT or PAINT-INCREMENTAL	 
					  0 ;length of gradient to draw
	)
	(gimp-image-select-item image CHANNEL-OP-REPLACE green-apple-layer)
	(plug-in-gauss RUN-NONINTERACTIVE image backlight-layer
	                                        90 90
											1 ;1 RLE or 0 IIR
	                                        )
	
	;STEP 12, creates stem of apple
	(gimp-selection-none image)
	(set! stalk-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Stalk" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image stalk-layer 0 0)     
	(gimp-image-set-active-layer image stalk-layer)
	;creates path-vector
	(set! path-vector (car (gimp-vectors-new image "stalk-vector")))
	(set! strokeid (car (gimp-vectors-bezier-stroke-new-moveto path-vector 786 393)))
	(gimp-vectors-bezier-stroke-cubicto path-vector strokeid 
	                                     782 326  ;first control point of the moveto point
	                                     ;906 148 ;first control point
										 803 215 ;second control point
										 855 182 ;end point
	)
	(gimp-image-insert-vectors image path-vector ;the vectors
	                                 0 ;the parent vectors
									 0)    ;position
	(gimp-context-set-foreground stem-color)
	(gimp-context-set-brush "2. Hardness 100")
	(gimp-context-set-brush-size 14)       ;well that didn't seem to set radius
	;we'll try our own brush
	(gimp-brush-set-hardness brush-name 1)
	(gimp-brush-set-radius brush-name 7)
	(gimp-brush-set-spacing brush-name 20)
	(gimp-context-set-brush brush-name)  
	(gimp-edit-stroke-vectors stalk-layer path-vector)
	;creates white
	
	(gimp-image-select-item image CHANNEL-OP-REPLACE stalk-layer)
	(set! stalk-highlight-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Stalk highlight" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image stalk-highlight-layer 0 0)     
	(gimp-image-set-active-layer image stalk-highlight-layer)
	(gimp-selection-shrink image 2)
	(gimp-edit-fill stalk-highlight-layer FILL-WHITE)
	(gimp-image-select-item image CHANNEL-OP-REPLACE stalk-layer)
	(plug-in-gauss RUN-NONINTERACTIVE image stalk-highlight-layer
	                                        45 45
											1 ;1 RLE or 0 IIR
	                                        )
	(python-layer-fx-inner-shadow 1 image stalk-layer '(0 0 0)
                                  75  ;opacity
                                  0   ;0 for Linear contour
                                  0   ;noise
								  LAYER-MODE-MULTIPLY-LEGACY   ;mode 19 for softlight  3 for multiply
								  1   ;source 0 for center 1 for edge check this one
								  0.0 ;choke
								  7  ;size
								  -90    ;offset-angle
								  15   ;offset-distance
								  FALSE ; merge with layer
	)
	(python-layer-fx-bevel-emboss 1
	                              image
								  stalk-layer
								  1 ;style 2 = emboss 1 = inner bevel
								  65 ;depth
								  0  ;direction 0 up 1 down
								  47 ;size
								  8  ;soften
								  140 ;angle
								  30.0 ;altitude
									3   ;gloss-contour 0 for linear 3 for cove deep
								 stem-highlight-color ;highlight color
								 LAYER-MODE-ADDITION-LEGACY ;highlight mode 5 OVERLAY
								 100.0  ;highlight opacity
	                             stem-shadow-color   ;shadow color
								    LAYER-MODE-MULTIPLY-LEGACY       ;shadow mode 3 multiply
	                              15.6      ;shadow opacity
								     6       ;surface contour half round
									FALSE     ; use texture
                                   "Pine" ;pattern	use clipboard from the copied step above
								   100     ;scale
								   100     ;depth
								   FALSE   ;invert
								   TRUE   ;merge with layer
     )   
	;adds perspective shadow layer
    (gimp-selection-none image)
	(set! stalk-layer (car(gimp-image-get-layer-by-name image "Stalk"))) ;we have to grab it because pointer is changed from the merge call
    ;unlike the documentation RUN MODE is not needed otherwise if entered it'll return a "argument 1 must be: a number" error
	(script-fu-perspective-shadow image 
								 stalk-layer
	                                                87.0       ;angle
													4.0	     ;distance of horizon
													0.5      ;length of shadow
													10       ;blur radius
													'(0 0 0)  ;color
														80  ;opacity
														 1  ;interpolation 1 for Linear 0 for None
													 0	    ;allow resizing
    )                              	
	 
	;steps here are added (different from tutorial to get rid of extra stem part by masking
	(set! stem-hide-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Stem hide" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image stem-hide-layer 0 0)     
	(gimp-image-set-active-layer image stem-hide-layer)
	(gimp-image-select-item image CHANNEL-OP-REPLACE dent-layer)
	(gimp-image-select-rectangle image CHANNEL-OP-ADD
	                                    626 108
	                                    314 226)
	(gimp-edit-fill stem-hide-layer FILL-WHITE)
	(gimp-image-select-item image CHANNEL-OP-REPLACE stem-hide-layer)
	
	;MASK stalk-layer
	(set! stalk-layer (car(gimp-image-get-layer-by-name image "Stalk")))
	(set! stem-mask (car (gimp-layer-create-mask stalk-layer ADD-MASK-SELECTION))) ;creates the mask before adding it
	(gimp-layer-add-mask stalk-layer stem-mask)        ;adds mask to dent-shadow channel
	
	(set! stalk-innershadow-layer (car(gimp-image-get-layer-by-name image "Stalk-innershadow")))
	(set! stem-mask (car (gimp-layer-create-mask stalk-innershadow-layer ADD-MASK-SELECTION))) ;creates the mask before adding it
	(gimp-layer-add-mask stalk-innershadow-layer stem-mask)        ;adds mask to dent-shadow channel
	
	(set! stalk-highlight-layer (car(gimp-image-get-layer-by-name image "Stalk highlight")))
	(set! stem-mask (car (gimp-layer-create-mask stalk-highlight-layer ADD-MASK-SELECTION))) ;creates the mask before adding it
	(gimp-layer-add-mask stalk-highlight-layer stem-mask)        ;adds mask to dent-shadow channel
	
	(set! perspective-shadow-layer (car(gimp-image-get-layer-by-name image "Perspective Shadow")))
	(set! stem-mask (car (gimp-layer-create-mask perspective-shadow-layer ADD-MASK-SELECTION))) ;creates the mask before adding it
	(gimp-layer-add-mask perspective-shadow-layer stem-mask)        ;adds mask to dent-shadow channel
	
	(gimp-layer-set-mode stem-hide-layer LAYER-MODE-MULTIPLY-LEGACY)     ;make it invisible using multiply mode
	;STEP 13
	;hide background and merge layers
	(gimp-selection-none image)
	(gimp-item-set-visible background-layer FALSE)
	(set! merged-layer (car (gimp-image-merge-visible-layers image 
	                                        0 ;0 EXPAND-AS-NECESSARY 1 CLIP-TO-IMAGE 2 CLIP-TO-BOTTOM-LAYER
	                         )))
    (gimp-item-set-visible background-layer TRUE)
	(plug-in-curve-bend RUN-NONINTERACTIVE image merged-layer
	                                       0.0 ;rotation
										   TRUE    ;Smoothing {TRUE,FALSE}
											TRUE   ;antialias{TRUE,FALSE}
											FALSE   ;work on copy {TRUE,FALSE}
	                                        0   ;curve-type 0 smooth 1 freehand
											5   ;{2 <= argc <= 17} upper
	                                        #(0 0.14 0.5 0.84 1)   ; array of 17 x point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
											5   ; upper argc
											#(0.5 0.38 0.31 0.38 0.5)    ; array of 17 y point_koords { 0.0 <= y <= 1.0 or -1 for unused point }
											   
											5   ; lower argc
											#(0 0.14 0.5 0.84 1)   ; array of 17 x point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
	                                        5   ; lower argc for y
											#(0.5 0.38 0.31 0.38 0.5)   ; array of 17 y point_koords { 0.0 <= x <= 1.0 or -1 for unused point }
	                                           
	                                        256   ;256 upper for free hand
											array256   ;array of 256 freehandkoord
											256   ;256 lower
											array256   ;array of 256 
	)
	;moves to center-ish of image
	(gimp-layer-translate merged-layer 0 -152)
	(gimp-layer-resize-to-image-size merged-layer)
	
	;STEP 14
	;fills background with background-dark-color
	(gimp-image-select-item image CHANNEL-OP-REPLACE background-layer)
	(gimp-context-set-foreground background-dark-color)
	(gimp-edit-fill background-layer FILL-FOREGROUND)
	;creates new layer with ellipse for light background color
	(set! background-light-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Light" 100 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image background-light-layer 0 1)  ;1 to insert just below green apple layer   
	(gimp-image-set-active-layer image background-light-layer)
	(gimp-ellipse-select image -150 605 1906 841 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-context-set-foreground background-light-color)
	(gimp-edit-fill background-light-layer FILL-FOREGROUND)
	;STEP 15
	(gimp-selection-none image)
	(plug-in-gauss RUN-NONINTERACTIVE image background-light-layer
	                                        350 350
											1 ;1 RLE or 0 IIR
	                                        )
	(set! shadow-layer (car (gimp-layer-new image width height
	                           RGBA-IMAGE "Shadow" 75 LAYER-MODE-NORMAL-LEGACY)))  ;creates layer
	(gimp-image-insert-layer image shadow-layer 0 1)  ;1 to insert just below green apple layer   
	(gimp-image-set-active-layer image shadow-layer)
	(gimp-ellipse-select image 363 840 858 210 CHANNEL-OP-REPLACE
	                                            TRUE ;antialiasing
												FALSE ;Feather option
												0     ;Feather radius
	)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-edit-fill shadow-layer FILL-FOREGROUND)
	(gimp-selection-none image)
	(plug-in-gauss RUN-NONINTERACTIVE image shadow-layer
	                                        75 75
											1 ;1 RLE or 0 IIR
	                                        )
	(gimp-image-scale image new-image-width (* (/ 1200 1600) new-image-width))
	; DONE
	; set some brush details so user doesn't get too surprised
	(gimp-brush-delete brush-name)        ;deletes the brush we created to draw dots, so it's not in memory 
	(gimp-context-set-brush "2. Hardness 025") ;sets some other brush so it doesn't use clipboard as brush
	(gimp-context-set-brush-size 20)           ;sets it to something like the default
	(set! new-display (car (gimp-display-new image)))      ;creates new display for image
	;(gimp-image-undo-group-end image)                     ;undo group in one step
	(gimp-displays-flush)
	)
)

(script-fu-register
  "script-fu-green-apple"         ;function name
  "<Image>/Script-Fu/Create New/Green Apple"    ;menu register
  "Creates a (green) apple, lets you choose colors of your choice."       ;description
  "Tin Tran"                          ;author name
  "copyright info and description"         ;copyright info or description
  "2014"                          ;date
  ""                        ;mode
  ;SF-IMAGE      "Image" 0                   
  ;SF-DRAWABLE   "Layer" 0
  ;SF-ADJUSTMENT "Threshold" '(127 0 255 1 10 0 0)
  ;SF-FILENAME "3D Brown texture" (string-append "" gimp-data-directory "/patterns/3D Brown texture pattern.jpg") ;(string-append "" gimp-data-directory "/scripts/beavis.jpg") 
  ;SF-FILENAME "Vitro Pattern" (string-append "" gimp-data-directory "/patterns/Vitro.pat")
  ;SF-FILENAME "Frosted Glass texture" (string-append "" gimp-data-directory "/patterns/Frosted Glass texture.jpg")
  ;SF-COLOR       "Stroke(background) color"       '(43 37 29)
  ;SF-PATTERN     "Background texture (3D Brown texture)" "3D Brown texture pattern.jpg"
  ;SF-PATTERN     "Glass pattern (Vitro)" "Vitro"
  ;SF-PATTERN     "Frosted Glass texture" "Frosted Glass texture.jpg"
  SF-COLOR        "Apple Light Green" '(142 210 54) 
  SF-COLOR        "Apple Dark Green"  '(0 80 32)
  SF-COLOR        "Dots color"        '(204 221 153)
  SF-COLOR        "Yellow 1 (small circle)" '(255 193 6)
  SF-COLOR        "Yellow 2 (large circle)" '(255 245 89)
  SF-COLOR        "Stem color"        '(49 16 0)
  SF-COLOR        "Stem highlight color" '(92 30 0)
  SF-COLOR        "Stem shadow color"    '(53 26 0)
  SF-COLOR        "Background dark"      '(0 73 0)
  SF-COLOR        "Background light"     '(55 142 55)
  SF-ADJUSTMENT   "Image Width" '(1600 0 2000 1 50 0 0)
)

